#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _student
{
	char *ime; //alociracemo dinamicki u zavisnosti od velicine imena
	int ocene[10];
	double prosek;
}student;

void greska(char *s)
{
	printf("greska: %s\n", s);
	exit(EXIT_FAILURE);
}

int main()
{
	int i, j;
	student *studenti;
	int n;
	FILE *f = fopen("ocene.txt", "r");
	if (f == NULL)
		greska("otvaranje datoteke");

	fscanf(f, "%d", &n);

	//kada procitamo broj studenata prvo 
	//alociramo memoriju
	studenti =
		(student*)malloc(n * sizeof(student));

	if (studenti == NULL)
		greska("alokacija");

	for (i = 0; i < n; i++)
	{
		//citamo studenta po studenta
		//prvo citamo ime i prezime
		char pom[200];
		char pom2[200];
		fscanf(f, "%s", pom); //ime
		fscanf(f, "%s", pom2); //prezime
 		strcat(pom, " "); //ime + " "
		strcat(pom, pom2);//ime + " " + prezime

		studenti[i].ime =
			(char*)malloc(
			(strlen(pom) + 1) * sizeof(char));
		if (studenti[i].ime == NULL)
			greska("alokacija");

		strcpy(studenti[i].ime, pom);
		double prosek = 0;
		for (j = 0; j < 10; j++)
		{
			fscanf(f, "%d", &studenti[i].ocene[j]);
			prosek += studenti[i].ocene[j];
		}
		studenti[i].prosek = prosek / 10;
	}

	fclose(f);

	int i_maxp = 0;
	double maxp = studenti[0].prosek;
	for (i = 1; i < n; i++)
	{
		if (studenti[i].prosek > maxp)
		{
			maxp = studenti[i].prosek;
			i_maxp = i;
		}
	}
	
	printf("student sa najvecim prosekom je %s i njegov prosek je %lf\n",
		studenti[i_maxp].ime,
		studenti[i_maxp].prosek
		);

	for (i = 0; i < n; i++)
		free(studenti[i].ime);
	free(studenti);
	return 0;
}